<template>
    <block type="consult" v-bind="$attrs">
        <div class="container">
            <div class="consult__header">
                <template v-if="windowWidth >= 768">
                    <ul class="consult__header-coach">
                        <li>
                            <label>
                                <input class="visually-hidden" type="radio" name="consult-coach" v-model="selectionCoach" value="null" checked>
                                <span class="consult__switch-imitate">Все тренеры</span>
                            </label>
                        </li>
                        <li v-for="(coach, index) in coaches" :key="index">
                            <label>
                                <input class="visually-hidden" type="radio" name="consult-coach" v-model="selectionCoach" :value="coach">
                                <span class="consult__switch-imitate">{{ coach }}</span>
                            </label>
                        </li>
                    </ul>
                </template>
                <template v-if="windowWidth < 768">
                    <div class="select--arrow">
                        <select class="consult__header-coach--select" name="consult-coach" v-model="selectionCoach">
                            <option value="null" selected>Все тренеры</option>
                            <option v-for="(coach, index) in coaches" :key="index" :value="coach">{{ coach }}</option>
                        </select>
                    </div>
                </template>
            </div>
            <div class="consult__content">
                <card-event 
                v-for="(item, index) in itemsVisible" 
                :key="index"
                :item="item"
                v-show="(index + 1) > ((pagination.currentPage - 1) * pagination.perPage) && (index + 1) <= (pagination.currentPage * pagination.perPage)"
                ></card-event>
            </div>
            <div class="consult__footer pagination" v-if="(itemsCount / pagination.perPage) > 1">
                <div class="pagination__items">
                    <button 
                    :class="{active: pagination.currentPage == page}" 
                    v-for="page in Math.ceil((itemsCount / pagination.perPage))" 
                    :key="page" 
                    @click="pagination.currentPage = page; scrollToStart()"
                    >{{ page }}</button>
                </div>
            </div>
        </div>
    </block>
</template>

<script>
import SmoothScroll from "smooth-scroll";
import map from "lodash-es/map";
import filter from "lodash-es/filter";
import union from "lodash-es/union";
import forEach from "lodash-es/forEach";

export default {
    props: ['params', 'content', 'items'],
    data() {
        return {
            items_: this.items || require('@js/samples').default.load('consultation'),
            itemsVisible: [],
            itemsCount: 0,
            selectionCoach: null,
            pagination: {
                perPage: 9,
                currentPage: 1
            },
            windowWidth: this.getWindowWidth()
        }
    },
    watch: {
        selectionCoach: function (value) {
            this.itemsVisible = this.items_;
            this.pagination.currentPage = 1;

            this.itemsVisible = value ? map(this.itemsVisible, function(item) {
                item.hidden = true;
                forEach(item.speakers, function(coach) {
                    if (!item.hidden || value === coach || value == 'null') {
                        item.hidden = false;
                    }
                });
                return item;
            }) : this.items_;
            this.itemsVisible = filter(this.itemsVisible, function(e) { return !e.hidden; });
            this.itemsCount = this.itemsVisible.length;
        },
    },
    mounted () {
        this.itemsCount = this.items_.length;
        this.itemsVisible = this.items_;
        this.$nextTick(() => {
            window.addEventListener('resize', () => {
                this.windowWidth = this.getWindowWidth();
            });
        })
    },
    computed: {
        coaches: function () {
            // return _.union(_.flatten(_.map(this.items_, 'speakers')));
            return union.apply(null, map(this.items_, 'speakers'));
        },
    },
    methods: {
        getWindowWidth () {
            return window.innerWidth;
        },
        scrollToStart: () => {
            (new SmoothScroll()).animateScroll(document.querySelector('.section-consult'));
        }
    }
}
</script>